---
title: XRWebGLLayerInit.depth
slug: Web/API/XRWebGLLayerInit/depth
tags:
  - API
  - AR
  - Buffer
  - Compositing
  - Depth
  - Distance
  - Property
  - Reality
  - Reference
  - VR
  - Virtual
  - WebGL
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRWebGLLayerInit
  - augmented
  - rendering
---
<p>{{APIRef("WebXR Device API")}}{{securecontext_header}}</p>

<p><span class="seoSummary">When using the {{domxref("XRWebGLLayer.XRWebGLLayer", "XRWebGLLayer()")}} constructor to create a new WebGL rendering layer for WebXR, providing as the <code>layerInit</code> parameter an object whose <code><strong>depth</strong></code> property is <code>false</code> will request that the new layer be created without a depth buffer.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">let layerInit = {
  depth: false
};
let glLayer = new XRWebGLLayer(xrSession, gl, layerInit);

let glLayer = new XRWebGLLayer(xrSession, gl, { depth: false });
</pre>

<h3 id="Value">Value</h3>

<p>A Boolean which can be set to <code>false</code> to specify that the new WebGL layer should not have a depth buffer. This means that the only source for depth information is the vertex coordinates, and reduces the accuracy and quality of rendering, but may potentially affect the performance of rendering as well.</p>

<p>The default value is <code>true</code>.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>This property differs from {{domxref("XRWebGLLayerInit.ignoreDepthValues", "ignoreDepthValues")}} in that a layer created with <code>ignoreDepthValues</code> set to <code>true</code> may still have a depth buffer, but will not make use of it.</p>

<p>You can determine whether or not the depth buffer is being used by a given WebGL rendering layer during your XR session by checking the value returned by {{domxref("XRWebGLLayer.ignoreDepthValues")}}. If this is <code>true</code>, then the depth buffer is either not present or is being ignored.</p>

<pre class="brush: js">if (glLayer.ignoreDepthValues) {
  /* not using the depth buffer */
}</pre>

<h2 id="Example">Example</h2>

<p>In this example, a new {{domxref("XRWebGLLayer")}} is created for a WebXR session, <code>xrSession</code>, without a depth buffer.</p>

<pre class="brush: js">xrSession.updateRenderState({
  baseLayer: new XRWebGLLayer(xrSession, gl, {
     depth: false
  });
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrwebgllayerinit-depth','XRWebGLLayerInit.depth')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRWebGLLayerInit.depth")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebGL_API/Tutorial/Getting_started_with_WebGL">Getting started with WebGL</a></li>
 <li>{{domxref("XRWebGLLayer.ignoreDepthValues")}}</li>
</ul>
